﻿local TimeSinceLastUpdate = 0
local BG_Color = 0

if (not SoW_Clock) then -- 이 설정은 WTF 파일이 없는(최초 설치시) 경우에 설정되는 기본 사항입니다.
  ConsoleExec("ScriptProfile 1");

	SoW_Clock = {};
    SoW_Clock.MemSet = 0; -- 메모리 표시 종류 설정| 0=통합, 1=애드온, 2=와우기본UI
    SoW_Clock.MemSize = 25; -- 경고 시작할 메모리 용량
    SoW_Clock.TipSet = 0; -- 툴팁 표시 설정 | 0 = 메모리, 1 = CPU
    SoW_Clock.TipList = 30; -- 애드온 표시 리스트 갯수 설정
    SoW_Clock.TimeType = 0; -- 시간 표시 방법 설정 | 0 = 12시간 단위, 1 = 24시간 단위
    SoW_Clock.Scale = 1; -- 애드온의 크기 비율
    SoW_Clock.OClock = true; -- 정시 알림 소리 설정 | false = 미사용, true = 사용
    SoW_Clock.CleanTime = 5; -- 자동 메모리 정리 간격 | 단위는 분, 0일 경우 미사용
    SoW_Clock.CombatToolTipRemove = true; -- 전투중 툴팁 비활성화 | true = 비활성화, false = 활성화
    SoW_Clock.TimeSetType = 0; -- 0 = 클라이언트, 1 = 서버, 2 = UTC
    SoW_Clock.ShowType = 0; -- 0 = 시계 + 브로커, 1 = 브로커
    SoW_Clock.BrokerShowSet = 0; -- 0 = 시계, 1 = 프레임, 2 = 메모리, 3 = 핑, 4 = 프레임+메모리+핑, 5 = 겨손 타이머, 6 = 바요 타이머
    SoW_Clock.BattleField = false; -- 전장 대기 알림 설정
end

local ClockFrame = CreateFrame("Button", "SoW_Clock_Frame", UIParent) 
ClockFrame:SetPoint("CENTER", UIParent, "CENTER", x, y)
ClockFrame:SetHeight(38)
ClockFrame:SetWidth(160)
ClockFrame:SetMovable(true)
ClockFrame:SetUserPlaced(true)
ClockFrame:EnableMouse("false")
ClockFrame:Show()

--ClockFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

local ClockFrame_BackGround = ClockFrame:CreateTexture(nil, "BACKGROUND")
ClockFrame_BackGround:SetAllPoints(ClockFrame)
ClockFrame_BackGround:SetTexture(0, 0, 0, 0)
--ClockFrame_BackGround:Hide()

local TimeShadowString =  ClockFrame:CreateFontString(nil, "OVERLAY")
TimeShadowString:SetPoint("CENTER", ClockFrame, "CENTER", -30, 5)
TimeShadowString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 26)
TimeShadowString:SetTextColor(1,1,1)

local TimeString =  ClockFrame:CreateFontString(nil, "OVERLAY")
TimeString:SetPoint("CENTER", ClockFrame, "CENTER", -31, 6)
TimeString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 26)
TimeString:SetTextColor(0,0.6,1)

local DateString = ClockFrame:CreateFontString(nil, "OVERLAY")
DateString:SetPoint("CENTER", ClockFrame, "CENTER", 48, 10.5)
DateString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 12)
--DateString:SetTextColor(0.8,0.8,0.8)

local MidnSecString = ClockFrame:CreateFontString(nil, "OVERLAY")
MidnSecString:SetPoint("CENTER", ClockFrame, "CENTER", 36.5, -0.65)
MidnSecString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 12)
MidnSecString:SetTextColor(0.8,0.8,0.8)

local WeekString = ClockFrame:CreateFontString(nil, "OVERLAY")
WeekString:SetPoint("CENTER", ClockFrame, "CENTER", 64, 0.5)
WeekString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\NHNGodicB.TTF", 12)
--WeekString:SetTextColor(0.8,0.8,0.8)

local InfoString = ClockFrame:CreateFontString(nil, "OVERLAY")
InfoString:SetPoint("CENTER", ClockFrame, "CENTER", 0, -11)
InfoString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrostyleBEAtt.TTF", 12)
--InfoString:SetTextColor(0.8,0.8,0.8)

ClockFrame:SetScript("OnLoad", function(self)
  TimeManagerClockButton:Hide()
  ClockFrame:RegisterForDrag("LeftButton", "RightButton");
end)

ClockFrame:SetScript("OnUpdate", function(self, elapsed)
  Now = date("%S");
	
	if ( Now ~= TimeSinceLastUpdate ) then
  	if SoW_Clock.ShowType == 0 then
    	if CalendarGetNumPendingInvites() > 0 then -- 미응답 일정 갯수 반환함수
    	  if BG_Color == 0 then
          ClockFrame_BackGround:SetTexture(0, 0.6, 1, 0.75)
          BG_Color = 1
        elseif BG_Color == 1 then
          ClockFrame_BackGround:SetTexture(1, 0, 0.6, 0.75)
          BG_Color = 2
        elseif BG_Color == 2 then
          ClockFrame_BackGround:SetTexture(0.6, 1, 0, 0.75)
          BG_Color = 0
        end
      else
        ClockFrame_BackGround:SetTexture(0, 0, 0, 0)
      end
	
      SoW_Clock_Frame:SetScale(SoW_Clock.Scale*1)
  
      local l_WeekName = {"|CFFFF4444일|r","월","화","수","목","금","|CFF4444BB토|r"};
    	local l_DateText = string.format("%s%s%s",date("|cFFFFCC00%m|r"),"|cFFFFFFFF/|r",date("|cFFFFCC00%d|r"));
    	--local l_DateText1; -- 시각 표시
    	--local l_DateText2; -- 오전/후 or 초 표시
      local l_DateText1, l_DateText2 = SoW_TimeReturn(SoW_Clock.TimeType, SoW_Clock.TimeSetType, "SoW_Clock.lua")
  
--local hour, minute = GetGameTime()
--print(hour .. ":" .. minute) 서버
--print(date("%H") .. ":" .. date("%M")) 클라이언트
--print(date("!%H") .. ":" .. date("!%M")) UTC
  
    	local I_DateText3 = l_WeekName[tonumber(date("%w")+1)]; -- 요일 표시
	
    	DateString:SetText(l_DateText);
    	TimeString:SetText(l_DateText1);
    	TimeShadowString:SetText(l_DateText1);
    	MidnSecString:SetText(l_DateText2);
    	WeekString:SetText("|cFFFFFFFF[|r"..I_DateText3.."|cFFFFFFFF]|r");

	-- FPS & 메모리 & 네트웍지연율
    	local l_InfoText = SoW_FPS_Return() .. " " .. SoW_WoWMem_Return() .. " " .. SoW_Network_Status_Return(0);
    	InfoString:SetText(l_InfoText);
	
    	TimeSinceLastUpdate = date("%S");
  	
    	if SoW_Clock.BattleField then
        SoW_BattleFieldArarm()
      end
      
      OClockNCleanTime()
    
    else
      ClockFrame:Hide()
  	end
	end
end)




-- 시계 프레임 클릭 스크립트
ClockFrame:SetScript("OnMouseDown", function(self, button)
	if (IsAltKeyDown() and button == "LeftButton") then
		--ClockFrame:ClearAllPoints()
		--ClockFrame:StartMoving()
		ClockFrame:StartMoving();
	else
	  Click_Event(button)
	end
end)
ClockFrame:SetScript("OnClick", function()

end)
ClockFrame:SetScript("OnMouseUp", function()
	ClockFrame:StopMovingOrSizing()
end)
ClockFrame:SetScript("OnEnter", function(self)
  if SoW_Clock.CombatToolTipRemove == true then
    if InCombatLockdown() == nil then
      GameTooltip:SetOwner(self, "ANCHOR_NONE");
      GameTooltip:ClearAllPoints();
      GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
      GameTooltip:ClearLines();
      SoW_TooltipShow(SoW_Clock.TipSet, SoW_Clock.TipList, SoW_Clock.MemSize)
    end
  else
    GameTooltip:SetOwner(self, "ANCHOR_NONE");
    GameTooltip:ClearAllPoints();
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
    GameTooltip:ClearLines();
    SoW_TooltipShow(SoW_Clock.TipSet, SoW_Clock.TipList, SoW_Clock.MemSize)
  end
end)

ClockFrame:SetScript("OnLeave", function()
  GameTooltip:Hide()
end)


function MenuListShow()

end